import java.applet.*;
import java.awt.*;

public class Fader2 extends Applet
  implements Runnable {	
 
 int speed=50;
 int xPos=0;
 int yPos=0;
 int direction[]=new int[3];	
 int color[]=new int[3]; 
 String msg;
 Font outFont; 
 Thread processus;		 


 public void init() {
  for (int i=0; i<3; i++) direction[i]=-1;
  for (int i=0; i<3; i++) color[i]=255;
  msg=getParameter("texte");
  if (msg==null) msg="Message.";
  outFont=new Font("SansSerif",Font.BOLD,getSize().height); 
  setFont(outFont);
  setBackground(Color.white);
  FontMetrics fm=getFontMetrics(outFont);
  xPos=(getSize().width-fm.stringWidth(msg))/2;
  yPos=(getSize().height-fm.getHeight())/2+fm.getAscent();
 }

 public void paint(Graphics g) {
  g.setColor(new Color(color[0],color[1],color[2]));
  g.setFont(outFont); 
  g.drawString(msg, xPos, yPos);
 }

 public void update(Graphics g) {
  paint(g);
 } 

 public void start() {
  if (processus == null) {
   processus = new Thread(this);
   processus.start();
  }
 }

 public boolean changeColor(int i) {
  color[i]=color[i]+direction[i]*5;
  if (color[i]<0) {
    color[i]=0;
    direction[i]=1;
    return true;
  } 
  if (color[i]>255) {
    color[i]=255;
    direction[i]=-1;
    return true;
  } 
  return false;
 }
 
 public void run() {
  //on fait voluer l'une des composantes RVB  chaque fois
  int numCol=0;
  while (processus!=null) {
   if (changeColor(numCol)) {
    numCol=(int)(Math.random()*3);
   } 
   repaint();
   try { 
    processus.sleep(speed); 
   } catch (InterruptedException e) {}
  }
 }

 public void stop() {
  if (processus != null) {
   processus.stop();
   processus = null;
  }
 }
}
