import java.applet.*;
import java.awt.*;

public class Psyche1 extends Applet 
 implements Runnable {
  char[] texte;
  Thread processus;
  FontMetrics metrics;
  Image imageTexte; 
  Graphics gcImage;
  int largeur, hauteur;
  int xt,yt;
  int speed=100;
  
  public void init() {
   setBackground (Color.white);
   largeur=getSize ().width;
   hauteur=getSize ().height;
   // Rcupration du texte  afficher
   String S=getParameter ("Texte");
   texte=S.toCharArray();
  
  }
  
  public void start () {
   if (imageTexte==null) {
    imageTexte=createImage(largeur,hauteur);
    gcImage=imageTexte.getGraphics();
    gcImage.setFont(new Font("SansSerif", Font.BOLD, hauteur-4));
    metrics=gcImage.getFontMetrics();
    xt=(largeur-metrics.stringWidth(texte.toString()))/2;
    yt=hauteur-metrics.getDescent();
   }
   // Cration et dmarrage du thread d'animation
   if (processus==null) { 
    processus = new Thread (this);
    processus.start();
   } 
  }
  
  public void stop () {
   if (processus!=null) {
    processus.stop();
    processus=null;
   } 
  }
  
  public void run() {
   while (processus!=null) {
    repaint();
    redessine();
    try {
     processus.sleep(speed);
    }
    catch (InterruptedException e) {}
   } 
  }
  
  public void paint (Graphics g) {
   g.drawImage(imageTexte, 0, 0, this);
  }

  int hasard(int n) {
   return (int)Math.floor(Math.random()*n);
  }
  
  public void redessine() {
   gcImage.setColor(Color.white);
   gcImage.fillRect(0,0, largeur, hauteur);
   int x=xt;
   for (int i=0; i<texte.length; i++) {
    gcImage.setColor (new Color(hasard(255),hasard(255),hasard(255)));
    gcImage.drawChars(texte,i,1,x,yt+hasard(8)-4);
    x=x+metrics.charWidth(texte[i]);
   } 
  }

  public void update(Graphics g) {
   paint(g);
  } 
  
}
 
